﻿Public Class FormTest

#Region " Page Events "

    Private Sub FormTest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            GroupBoxLogin.Text = ButtonLogin.Text
            GroupBoxProject.Text = ButtonGetProjects.Text
            GroupBoxProjectType.Text = ButtonGetProjectTypes.Text
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLogin.Click
        Try
            TextBoxGUID.Clear()
            TextBoxGUID.Text = Sample.Login(TextBoxSubDomain.Text, _
                                            TextBoxUsername.Text, _
                                            TextBoxPassword.Text)
            MessageBox.Show(String.Format("{0} successfull.", ButtonLogin.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonGetrojects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetProjects.Click
        Try
            GetProjects()
            MessageBox.Show(String.Format("{0} successfull.", ButtonGetProjects.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonGetProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetProject.Click
        Dim dtOutput As DataTable = Nothing
        Dim projectId As Integer = 0
        Try
            If DataGridViewProject.CurrentRow Is Nothing OrElse DataGridViewProject.CurrentRow.Index = -1 Then Return
            projectId = CType(DataGridViewProject.Rows(DataGridViewProject.CurrentRow.Index).Cells(0).Value, Integer)
            dtOutput = Sample.GetProjects(TextBoxGUID.Text, projectId)
            TextBoxProjectId.Text = dtOutput.Rows(0).Item("PROJECT_ID").ToString
            TextBoxProjectNumber.Text = dtOutput.Rows(0).Item("PROJECT_NUMBER").ToString
            TextBoxProjectName.Text = dtOutput.Rows(0).Item("PROJECT_NAME").ToString
            If dtOutput.Rows(0).Item("PROJECT_DESC") Is DBNull.Value Then
                TextBoxProjectDescription.Clear()
            Else
                TextBoxProjectDescription.Text = dtOutput.Rows(0).Item("PROJECT_DESC").ToString
            End If
            CheckBoxTemplate.Checked = CType(dtOutput.Rows(0).Item("PROJECT_TEMPLATE"), Boolean)
            MessageBox.Show(String.Format("{0} successfull.", ButtonGetProject.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        Finally
            If dtOutput IsNot Nothing Then
                dtOutput.Dispose()
                dtOutput = Nothing
            End If
        End Try
    End Sub

    Private Sub ButtonUpdateProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUpdateProject.Click
        Try
            Sample.SaveProject(TextBoxGUID.Text, CType(TextBoxProjectId.Text, Integer), TextBoxProjectNumber.Text, TextBoxProjectName.Text, TextBoxProjectDescription.Text, CheckBoxTemplate.Checked)
            GetProjects()
            MessageBox.Show(String.Format("{0} successfull.", ButtonUpdateProject.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonCreateProjectFromTemplate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCreateProjectFromTemplate.Click
        Dim dtOutput As DataTable = Nothing
        Try
            If CheckBoxFromTemplate.Checked Then
                Sample.CreateProjectsFromTemplate(TextBoxGUID.Text, TextBoxProjectNumber2.Text, TextBoxProjectName2.Text, TextBoxProjectDescription2.Text, CType(ComboBoxProjectTemplate.SelectedValue, Integer))
            Else
                Sample.CreateProjectsFromTemplate(TextBoxGUID.Text, TextBoxProjectNumber2.Text, TextBoxProjectName2.Text, TextBoxProjectDescription2.Text)
            End If
            dtOutput = Sample.GetProjects(TextBoxGUID.Text)
            If dtOutput IsNot Nothing Then
                DataGridViewProject.DataSource = dtOutput
                GroupBoxProject.Text = String.Format("{0} ({1})", ButtonGetProjects.Text, dtOutput.Rows.Count)
            End If
            GetProjects()
            MessageBox.Show(String.Format("{0} successfull.", ButtonCreateProjectFromTemplate.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        Finally
            If dtOutput IsNot Nothing Then
                dtOutput.Dispose()
                dtOutput = Nothing
            End If
        End Try
    End Sub

    Private Sub ButtonGetProjectTypes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetProjectTypes.Click
        Try
            GetProjectTypes()
            MessageBox.Show(String.Format("{0} successfull.", ButtonGetProjectTypes.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonGetProjectType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGetProjectType.Click
        Dim dtOutput As DataTable
        Dim projectTypeId As Integer = 0
        Try
            If DataGridViewProjectType.CurrentRow Is Nothing OrElse DataGridViewProjectType.CurrentRow.Index = -1 Then Return
            projectTypeId = CType(DataGridViewProjectType.Rows(DataGridViewProjectType.CurrentRow.Index).Cells(0).Value, Integer)
            dtOutput = Sample.GetProjectTypes(TextBoxGUID.Text, projectTypeId)
            TextBoxProjectTypeId.Text = dtOutput.Rows(0).Item("PROJECT_TYPE_ID").ToString
            TextBoxProjectTypeName.Text = dtOutput.Rows(0).Item("PROJECT_TYPE_NAME").ToString
            If dtOutput.Rows(0).Item("PROJECT_TYPE_DESCRIPTION") Is DBNull.Value Then
                TextBoxProjectTypeDesc.Clear()
            Else
                TextBoxProjectTypeDesc.Text = dtOutput.Rows(0).Item("PROJECT_TYPE_DESCRIPTION").ToString
            End If
            MessageBox.Show(String.Format("{0} successfull.", ButtonGetProjectType.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonSaveProjectType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveProjectType.Click
        Dim projectId As Integer = 0
        Try
            If String.IsNullOrEmpty(TextBoxProjectTypeId.Text) Then
                Sample.SaveProjectType(TextBoxGUID.Text, 0, TextBoxProjectTypeName.Text, TextBoxProjectTypeDesc.Text, 0, False)
            Else
                Sample.SaveProjectType(TextBoxGUID.Text, CType(TextBoxProjectTypeId.Text, Integer), TextBoxProjectTypeName.Text, TextBoxProjectTypeDesc.Text, 0, False)
            End If
            GetProjectTypes()
            MessageBox.Show(String.Format("{0} successfull.", ButtonUpdateProject.Text), Me.Text)
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonProjectTypeClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonProjectTypeClear.Click
        Try
            TextBoxProjectTypeId.Clear()
            TextBoxProjectTypeName.Clear()
            TextBoxProjectTypeDesc.Clear()
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub CheckBoxFromTemplate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxFromTemplate.CheckedChanged
        Try
            GetProjectsTemplate()
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text)
        End Try
    End Sub

    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click
        Me.Close()
    End Sub

#End Region

#Region " Functions "

    Private Sub GetProjects()
        Dim dtOutput As DataTable = Nothing
        Try
            dtOutput = Sample.GetProjects(TextBoxGUID.Text)
            If dtOutput IsNot Nothing Then
                DataGridViewProject.DataSource = dtOutput
                GroupBoxProject.Text = String.Format("{0} ({1})", ButtonGetProjects.Text, dtOutput.Rows.Count)
            End If
            GetProjectsTemplate()
        Catch ex As Exception
            Throw
        Finally
            If dtOutput IsNot Nothing Then
                dtOutput.Dispose()
                dtOutput = Nothing
            End If
        End Try
    End Sub

    Private Sub GetProjectsTemplate()
        Dim dtOutput As DataTable = Nothing
        Try
            If CheckBoxFromTemplate.Checked Then
                dtOutput = Sample.GetProjects(TextBoxGUID.Text)
                If dtOutput IsNot Nothing Then
                    Dim dv As DataView = dtOutput.DefaultView
                    dv.RowFilter = "PROJECT_TEMPLATE=1"
                    ComboBoxProjectTemplate.DataSource = dv
                    ComboBoxProjectTemplate.DisplayMember = "PROJECT_NAME"
                    ComboBoxProjectTemplate.ValueMember = "PROJECT_ID"
                    GroupBoxProject.Text = String.Format("{0} ({1})", ButtonGetProjects.Text, dtOutput.Rows.Count)
                End If
            Else
                ComboBoxProjectTemplate.DataSource = New DataTable
            End If
        Catch ex As Exception
            Throw
        Finally
            If dtOutput IsNot Nothing Then
                dtOutput.Dispose()
                dtOutput = Nothing
            End If
        End Try
    End Sub

    Private Sub GetProjectTypes()
        Dim dtOutput As DataTable = Nothing
        Try
            dtOutput = Sample.GetProjectTypes(TextBoxGUID.Text)
            If dtOutput IsNot Nothing Then
                DataGridViewProjectType.DataSource = dtOutput
                GroupBoxProjectType.Text = String.Format("{0} ({1})", ButtonGetProjectTypes.Text, dtOutput.Rows.Count)
            End If
        Catch ex As Exception
            Throw
        Finally
            If dtOutput IsNot Nothing Then
                dtOutput.Dispose()
                dtOutput = Nothing
            End If
        End Try
    End Sub

#End Region

End Class