﻿#Region " Imports "

Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Collections.Specialized
Imports System.Net
Imports System.IO

#End Region

Public Class Sample

#Region " Constants "

    Public Const API_URL As String = "https://ace-prod-api.aceproject.com"

#End Region

    Public Shared Function Login(ByVal _subDomain As String, ByVal _username As String, ByVal _password As String) As String
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim guid As String = String.Empty
        Dim sb As New System.Text.StringBuilder
        Try
            sb = New System.Text.StringBuilder
            'Building API QueryString
            sb.Append("fct=Login")
            sb.Append(String.Format("&accountid={0}", _subDomain))
            sb.Append(String.Format("&username={0}", _username))
            sb.Append(String.Format("&password={0}", _password))
            sb.Append(String.Format("&ispasswordencrypt={0}", False.ToString))
            sb.Append(String.Format("&language={0}", "en-US"))
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
                'Retreive the guid from login function call
                If dsOutput.Tables(0).Columns.Contains("GUID") Then
                    guid = dsOutput.Tables(0).Rows(0).Item("GUID").ToString
                End If
            End If
            'Returning Login GUID used for each call later
            Return guid
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

    Public Shared Function GetProjects(ByVal _guid As String, Optional ByVal _projectid As Integer = 0) As DataTable
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim sb As New System.Text.StringBuilder
        Try
            'Building API QueryString
            sb = New System.Text.StringBuilder
            sb.Append("fct=getprojects")
            sb.Append(String.Format("&guid={0}", _guid))
            If _projectid > 0 Then
                sb.Append(String.Format("&projectid={0}", _projectid))
            End If
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
            End If
            'Returning Project table
            Return dsOutput.Tables(0)
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

    Public Shared Function CreateProjectsFromTemplate(ByVal _guid As String, _
                                                      ByVal _projectnumber As String, _
                                                      ByVal _projectname As String, _
                                                      ByVal _projectdesc As String, _
                                                      Optional ByVal _projectidTemplate As Integer = 0) As Integer
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim sb As System.Text.StringBuilder = Nothing
        Try
            'Building API QueryString
            sb = New System.Text.StringBuilder
            sb.Append("fct=createorcopyproject")
            sb.Append(String.Format("&guid={0}", _guid))
            sb.Append(String.Format("&projectnumber={0}", _projectnumber))
            sb.Append(String.Format("&projectname={0}", _projectname))
            sb.Append(String.Format("&projecttype={0}", "1")) 'General
            sb.Append(String.Format("&projectdesc={0}", _projectdesc))
            sb.Append(String.Format("&nexttasknumber={0}", "1"))
            sb.Append(String.Format("&budgethours={0}", "0"))
            sb.Append(String.Format("&budgetcost={0}", "0"))
            sb.Append(String.Format("&estimatedstartdate={0}", "NULL"))
            sb.Append(String.Format("&estimatedenddate={0}", "NULL"))
            sb.Append(String.Format("&estimatedhours={0}", "0"))
            sb.Append(String.Format("&estimatedexpenses={0}", "0"))
            sb.Append(String.Format("&actualstartdate={0}", "NULL"))
            sb.Append(String.Format("&actualenddate={0}", "NULL"))
            sb.Append(String.Format("&projectpriorityid={0}", "3")) 'Normal
            sb.Append(String.Format("&projectstatusid={0}", "1")) 'To do
            sb.Append(String.Format("&projecttemplate={0}", "0"))
            sb.Append(String.Format("&contactname={0}", "NULL"))
            sb.Append(String.Format("&contactphone={0}", "NULL"))
            sb.Append(String.Format("&contactemail={0}", "NULL"))
            sb.Append(String.Format("&contactcell={0}", "NULL"))
            sb.Append(String.Format("&contactfax={0}", "NULL"))
            sb.Append(String.Format("&defaultestimatedtime={0}", "0"))
            sb.Append(String.Format("&defaulttaskstartdate={0}", "1"))
            sb.Append(String.Format("&defaulttaskenddate={0}", "1"))
            sb.Append(String.Format("&defaulttaskactualdates={0}", "2"))
            sb.Append(String.Format("&clientid={0}", "NULL"))
            sb.Append(String.Format("&includeweekends={0}", "True"))
            sb.Append(String.Format("&createdefaults={0}", "False"))
            sb.Append(String.Format("&languagedefaults={0}", "EN"))
            If _projectidTemplate = 0 Then
                sb.Append(String.Format("&projecttemplateid={0}", "NULL"))
            Else
                sb.Append(String.Format("&projecttemplateid={0}", _projectidTemplate))
            End If
            sb.Append(String.Format("&keeptemplatelink={0}", "True"))
            sb.Append(String.Format("&copyprojectassignments={0}", "True"))
            sb.Append(String.Format("&copyprojectdocuments={0}", "True"))
            sb.Append(String.Format("&copyforumtopics={0}", "False"))
            sb.Append(String.Format("&copytasks={0}", "False"))
            sb.Append(String.Format("&adjusttaskdates={0}", "False"))
            sb.Append(String.Format("&copytaskdocuments={0}", "False"))
            sb.Append(String.Format("&copytaskassignments={0}", "False"))
            sb.Append(String.Format("&resetstatusid={0}", "NULL"))
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
            End If
            'Returning PROJECT_ID
            Return CType(dsOutput.Tables(0).Rows(0).Item("PROJECT_ID"), Integer)
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

    Public Shared Function SaveProject(ByVal _guid As String, _
                                       ByVal _projectId As Integer, _
                                       ByVal _projectnumber As String, _
                                       ByVal _projectname As String, _
                                       ByVal _projectdesc As String, _
                                       ByVal _projectTemplate As Boolean) As Integer
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim sb As System.Text.StringBuilder = Nothing
        Dim dtProject As DataTable = Nothing
        Try
            dtProject = GetProjects(_guid, _projectId)
            'Building API QueryString
            sb = New System.Text.StringBuilder
            sb.Append("fct=updateproject")
            sb.Append(String.Format("&guid={0}", _guid))
            sb.Append(String.Format("&projectid={0}", _projectId))
            sb.Append(String.Format("&projectnumber={0}", _projectnumber))
            sb.Append(String.Format("&projectname={0}", _projectname))
            sb.Append(String.Format("&projecttypeid={0}", dtProject.Rows(0).Item("PROJECT_TYPE")))
            sb.Append(String.Format("&projectdesc={0}", _projectdesc))
            sb.Append(String.Format("&nexttasknumber={0}", dtProject.Rows(0).Item("TASK_NUMBER")))
            sb.Append(String.Format("&budgethours={0}", dtProject.Rows(0).Item("BUDGET_HOURS")))
            sb.Append(String.Format("&budgetcost={0}", dtProject.Rows(0).Item("BUDGET_COST")))
            sb.Append(String.Format("&estimatedstartdate={0}", dtProject.Rows(0).Item("START_DATE")))
            sb.Append(String.Format("&estimatedenddate={0}", dtProject.Rows(0).Item("END_DATE")))
            sb.Append(String.Format("&estimatedprojecthours={0}", dtProject.Rows(0).Item("ESTIMATED_HOURS")))
            sb.Append(String.Format("&estimatedprojectexpenses={0}", dtProject.Rows(0).Item("ESTIMATED_EXPENSES")))
            sb.Append(String.Format("&actualstartdate={0}", dtProject.Rows(0).Item("ACTUAL_START_DATE")))
            sb.Append(String.Format("&actualenddate={0}", dtProject.Rows(0).Item("ACTUAL_END_DATE")))
            sb.Append(String.Format("&projectpriorityid={0}", dtProject.Rows(0).Item("PROJECT_PRIORITY_ID")))
            sb.Append(String.Format("&projectstatusid={0}", dtProject.Rows(0).Item("PROJECT_STATUS_ID")))
            If _projectTemplate Then
                sb.Append(String.Format("&projecttemplate={0}", "1"))
            Else
                sb.Append(String.Format("&projecttemplate={0}", "0"))
            End If
            sb.Append(String.Format("&contactname={0}", dtProject.Rows(0).Item("CONTACT_NAME")))
            sb.Append(String.Format("&contactphone={0}", dtProject.Rows(0).Item("CONTACT_PHONE")))
            sb.Append(String.Format("&contactemail={0}", dtProject.Rows(0).Item("CONTACT_EMAIL")))
            sb.Append(String.Format("&contactcell={0}", dtProject.Rows(0).Item("CONTACT_CELLULAR")))
            sb.Append(String.Format("&contactfax={0}", dtProject.Rows(0).Item("CONTACT_FAX")))
            sb.Append(String.Format("&defaultestimatedtime={0}", dtProject.Rows(0).Item("DEFAULT_ESTI_TIME")))
            sb.Append(String.Format("&defaulttaskstartdate={0}", dtProject.Rows(0).Item("DEFAULT_TASK_START_DATE")))
            sb.Append(String.Format("&defaulttaskenddate={0}", dtProject.Rows(0).Item("DEFAULT_TASK_END_DATE")))
            sb.Append(String.Format("&defaulttaskactualdates={0}", dtProject.Rows(0).Item("DEFAULT_TASK_ACTUAL_DATES")))
            sb.Append(String.Format("&clientid={0}", dtProject.Rows(0).Item("CLIENT_ID")))
            sb.Append(String.Format("&includeweekends={0}", dtProject.Rows(0).Item("INCLUDE_WEEKENDS")))
            If dtProject.Rows(0).Item("MASTER_PROJECT_ID") Is DBNull.Value Then
                sb.Append(String.Format("&keeptemplatelink={0}", False.ToString))
            Else
                sb.Append(String.Format("&keeptemplatelink={0}", True.ToString))
            End If
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
            End If
            'Returning PROJECT_ID
            Return CType(dsOutput.Tables(0).Rows(0).Item("PROJECT_ID"), Integer)
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dtProject IsNot Nothing Then
                dtProject.Dispose()
                dtProject = Nothing
            End If
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

    Public Shared Function GetProjectTypes(ByVal _guid As String, Optional ByVal _projectTypeId As Integer = 0) As DataTable
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim sb As New System.Text.StringBuilder
        Try
            'Building API QueryString
            sb = New System.Text.StringBuilder
            sb.Append("fct=getprojecttypes")
            sb.Append(String.Format("&guid={0}", _guid))
            If _projectTypeId > 0 Then
                sb.Append(String.Format("&projecttypeid={0}", _projectTypeId))
            End If
            'sb.Append(String.Format("&sortorder={0}", "NULL")) 'Optional parameter
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
            End If
            'Returning Project Types table
            Return dsOutput.Tables(0)
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

    Public Shared Function SaveProjectType(ByVal _guid As String, _
                                           ByVal _projectTypeId As Integer, _
                                           ByVal _projecttypeName As String, _
                                           ByVal _projecttypeDesc As String, _
                                           ByVal _myorder As Decimal, _
                                           ByVal _isDefault As Boolean) As Integer
        Dim strXML As String = String.Empty
        Dim dsOutput As DataSet = Nothing
        Dim sb As System.Text.StringBuilder = Nothing
        Try
            'Building API QueryString
            sb = New System.Text.StringBuilder
            sb.Append("fct=saveprojecttype")
            sb.Append(String.Format("&guid={0}", _guid))
            If _projectTypeId > 0 Then
                sb.Append(String.Format("&projecttypeid={0}", _projectTypeId))
            End If
            sb.Append(String.Format("&projecttypename={0}", _projecttypeName))
            sb.Append(String.Format("&projecttypedesc={0}", _projecttypeDesc))
            sb.Append(String.Format("&myorder={0}", _myorder))
            sb.Append(String.Format("&isdefault = {0}", _isDefault.ToString))
            sb.Append(String.Format("&format={0}", "ds"))
            'Calling API
            strXML = CallHttp(API_URL, sb.ToString, False)
            'Retreive Output structure generate by API
            dsOutput = Deserialize(Of DataSet)(strXML)
            If dsOutput IsNot Nothing AndAlso dsOutput.Tables.Count > 0 Then
                If dsOutput.Tables.Contains("dtAPIErrors") Then
                    Throw New Exception(String.Format("{0}: {1}", dsOutput.Tables(0).Rows(0).Item("ErrorNumber").ToString, dsOutput.Tables(0).Rows(0).Item("ErrorDescription").ToString))
                End If
            End If
            'Returning PROJECT_TYPE_ID
            Return CType(dsOutput.Tables(0).Rows(0).Item("PROJECT_TYPE_ID"), Integer)
        Catch ex As Exception
            Throw
        Finally
            If sb IsNot Nothing Then sb = Nothing
            If dsOutput IsNot Nothing Then
                dsOutput.Dispose()
                dsOutput = Nothing
            End If
        End Try
    End Function

#Region " HTTP Call Managment "

    Public Shared Function CallHttp(ByVal url As String, _
                                    ByVal params As String, _
                                    ByVal httpPost As Boolean) As String
        If httpPost Then
            Return CallHttpPost(url, params)
        Else
            Return CallHttpGet(url, params)
        End If
    End Function

    Protected Shared Function CallHttpGet(ByVal url As String, _
                                          ByVal params As String) As String

        Dim loHttp As HttpWebRequest
        If String.IsNullOrEmpty(params) Then
            loHttp = CType(WebRequest.Create(url), HttpWebRequest)
        Else
            loHttp = CType(WebRequest.Create(url & "?" & params), HttpWebRequest)
        End If
        loHttp.Method = "GET"
        loHttp.ContentType = "application/x-www-form-urlencoded"
        loHttp.Headers.Set("Pragma", "no-cache")
        loHttp.AllowAutoRedirect = True
        loHttp.KeepAlive = True
        loHttp.Timeout = 30 * 1000

        Dim loWebResponse As HttpWebResponse = CType(loHttp.GetResponse(), HttpWebResponse)
        Dim enc As Encoding = System.Text.Encoding.UTF8
        Dim loResponseStream As StreamReader = New StreamReader(loWebResponse.GetResponseStream(), enc)
        Dim lcHtml As String = loResponseStream.ReadToEnd()

        loWebResponse.Close()
        loResponseStream.Close()

        Return lcHtml
    End Function

    Protected Shared Function CallHttpPost(ByVal url As String, _
                                           ByVal params As String) As String
        Dim loHttp As HttpWebRequest
        'params = QueryStringEncode(params, TypeEncodeEnum.urlEncode)
        loHttp = CType(WebRequest.Create(url), HttpWebRequest)
        loHttp.Method = "POST"
        Dim requestWriter As StreamWriter = New StreamWriter(loHttp.GetRequestStream())

        If Not String.IsNullOrEmpty(params) Then
            requestWriter.Write(params)
        End If
        requestWriter.Close()
        loHttp.ContentType = "application/x-www-form-urlencoded"
        loHttp.Headers.Set("Pragma", "no-cache")
        loHttp.AllowAutoRedirect = True
        loHttp.KeepAlive = True
        loHttp.Timeout = 30 * 1000
        'loHttp.Referer = url

        Dim loWebResponse As HttpWebResponse = CType(loHttp.GetResponse(), HttpWebResponse)
        Dim enc As Encoding = System.Text.Encoding.UTF8
        Dim loResponseStream As StreamReader = New StreamReader(loWebResponse.GetResponseStream(), enc)
        Dim lcHtml As String = loResponseStream.ReadToEnd()

        loWebResponse.Close()
        loResponseStream.Close()

        Return lcHtml
    End Function

#End Region

#Region " Serialization "

    Public Shared Function Deserialize(Of T)(ByVal strXML As String) As T
        Dim objet As T = Nothing
        Dim objType As Type = GetType(T)
        Try
            If Not String.IsNullOrEmpty(strXML) Then
                Dim objSerializer As New System.Xml.Serialization.XmlSerializer(objType)
                Dim objText As New System.Text.StringBuilder()
                Dim objXmlReader As New StringReader(strXML)
                objet = DirectCast(objSerializer.Deserialize(objXmlReader), T)
                objXmlReader.Close()
            End If
            Return objet
        Catch ex As Exception
            Throw
        Finally
            If objet IsNot Nothing Then objet = Nothing
        End Try
    End Function

#End Region

End Class
